// ==============================================================
//
//  Copyright (c) 2002-2003 Alex Vinokur.
//
//  ------------------------------------------------------------
//  This file is part of C++ Simulator of a Post Machine.
//
//  C++ Simulator of a Post Machine is free software; 
//  you can redistribute it and/or modify it
//  under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License,
//  or (at your option) any later version.
//
//  C++ Simulator of a Post Machine is distributed in the hope 
//  that it will be useful, but WITHOUT ANY WARRANTY; 
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
//  See the GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with C++ Simulator of a Post Machine; 
//  if not, write to the Free Software Foundation, Inc., 
//  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//  ------------------------------------------------------------
// 
//  mailto:alexvn@connect.to
//  http://up.to/alexv
//
// ==============================================================




// ##############################################################
//
//  SOFTWARE : Nondeterministic Post Machine (C++ Simulator)
//  FILE     : defs.h
//
//  DESCRIPTION :
//         Common definitions
//
// ##############################################################




// ###############
#ifndef _DEFS_H
#define _DEFS_H

#include "common.h"

// =========
typedef unsigned int  command_t;
typedef string        symbol_t;
typedef string        shift_t;

typedef unsigned int  uint;
typedef unsigned long ulong;


// =========
#define LEFT_SHIFT      "L"
#define NO_SHIFT        "N"
#define RIGHT_SHIFT     "R"

#define EMPTY_ALPHABET_SYMBOL   "b"
#define LABEL_ALPHABET_SYMBOL   "1"


#endif	// _DEFS_H
